import{s as Te,n as Me,o as ke}from"../chunks/scheduler.b108d059.js";import{S as Se,i as _e,g as r,s,r as o,A as Ue,h as n,f as l,c as i,j as ye,u as p,x as m,k as ve,y as Le,a,v as c,d as f,t as h,w as u}from"../chunks/index.008de539.js";import{C as be}from"../chunks/CodeBlock.3968c746.js";import{H as G,E as Ce}from"../chunks/EditOnGithub.d1c48e3d.js";function Ee(oe){let d,j,A,V,$,q,g,pe="Chat UI features a powerful Web Search feature. A high level overview of how it works:",I,w,me="<li>Generate an appropriate search query from the user prompt using the <code>TASK_MODEL</code></li> <li>Perform web search via an external provider (i.e. Serper) or via locally scrape Google results</li> <li>Load each search result into playwright and scrape</li> <li>Convert scraped HTML to Markdown tree with headings as parents</li> <li>Create embeddings for each Markdown element</li> <li>Find the embedings clossest to the user query using a vector similarity search (inner product)</li> <li>Get the corresponding Markdown elements and their parent, up to 8000 characters</li> <li>Supply the information as context to the model</li>",F,y,N,v,ce="Many providers are supported for the web search, or you can use locally scraped Google results.",X,b,Q,T,fe="For locally scraped Google results, put <code>USE_LOCAL_WEBSEARCH=true</code> in your <code>.env.local</code>. Please note that you may hit rate limits as we make no attempt to make the traffic look legitimate. To avoid this, you may choose a provider, such as Serper, used on the official instance.",Y,M,W,k,he="<p>SearXNG is a free internet metasearch engine which aggregates results from various search services and databases. Users are neither tracked nor profiled.</p>",Z,S,ue='You may enable support via the <code>SEARXNG_QUERY_URL</code> where <code>&lt;query&gt;</code> will be replaceed with the query keywords. Please see <a href="https://docs.searxng.org/dev/search_api.html" rel="nofollow">the official documentation</a> for more information',z,_,de="Example: <code>https://searxng.yourdomain.com/search?q=&lt;query&gt;&amp;engines=duckduckgo,google&amp;format=json</code>",K,U,O,L,$e="Many third party providers are supported as well. The official instance uses Serper.",D,C,ee,E,te,x,ge="You may block or allow specific websites from the web search results. When using an allow list, only the links in the allowlist will be used. For supported search engines, the links will be blocked from the results directly. Any URL in the results that <strong>partially or fully matches</strong> the entry will be filtered out.",le,P,ae,R,se,H,we="By default, Playwright will execute all Javascript on the page. This can be intensive, requiring up to 6 cores for full performance, on some webpages. You may block scripts from running by settings <code>WEBSEARCH_JAVASCRIPT=false</code>. However, this will not block Javascript inlined in the HTML.",ie,J,re,B,ne;return $=new G({props:{title:"Web Search",local:"web-search",headingTag:"h1"}}),y=new G({props:{title:"Providers",local:"providers",headingTag:"h2"}}),b=new G({props:{title:"Local",local:"local",headingTag:"h3"}}),M=new G({props:{title:"SearXNG",local:"searxng",headingTag:"h3"}}),U=new G({props:{title:"Third Party",local:"third-party",headingTag:"h3"}}),C=new be({props:{code:"WURDX0FQSV9LRVklM0Rkb2NzLnlvdS5jb20lMjBhcGklMjBrZXklMjBoZXJlJTBBU0VSUEVSX0FQSV9LRVklM0RzZXJwZXIuZGV2JTIwYXBpJTIwa2V5JTIwaGVyZSUwQVNFUlBBUElfS0VZJTNEc2VycGFwaSUyMGtleSUyMGhlcmUlMEFTRVJQU1RBQ0tfQVBJX0tFWSUzRHNlcnBzdGFjayUyMGFwaSUyMGtleSUyMGhlcmU=",highlighted:`<span class="hljs-attr">YDC_API_KEY</span>=docs.you.com api key here
<span class="hljs-attr">SERPER_API_KEY</span>=serper.dev api key here
<span class="hljs-attr">SERPAPI_KEY</span>=serpapi key here
<span class="hljs-attr">SERPSTACK_API_KEY</span>=serpstack api key here`,wrap:!1}}),E=new G({props:{title:"Block/Allow List",local:"blockallow-list",headingTag:"h2"}}),P=new be({props:{code:"V0VCU0VBUkNIX0JMT0NLTElTVCUzRCU2MCU1QiUyMnlvdXR1YmUuY29tJTIyJTJDJTIwJTIyaHR0cHMlM0ElMkYlMkZleGFtcGxlLmNvbSUyRmZvbyUyRmJhciUyMiU1RCU2MCUwQVdFQlNFQVJDSF9BTExPV0xJU1QlM0QlNjAlNUIlMjJzdGFja292ZXJmbG93LmNvbSUyMiU1RCU2MA==",highlighted:'<span class="hljs-attr">WEBSEARCH_BLOCKLIST</span>=`[<span class="hljs-string">&quot;youtube.com&quot;</span>, <span class="hljs-string">&quot;https://example.com/foo/bar&quot;</span>]`\n<span class="hljs-attr">WEBSEARCH_ALLOWLIST</span>=`[<span class="hljs-string">&quot;stackoverflow.com&quot;</span>]`',wrap:!1}}),R=new G({props:{title:"Disabling Javascript",local:"disabling-javascript",headingTag:"h2"}}),J=new Ce({props:{source:"https://github.com/huggingface/chat-ui/blob/main/docs/source/configuration/web-search.md"}}),{c(){d=r("meta"),j=s(),A=r("p"),V=s(),o($.$$.fragment),q=s(),g=r("p"),g.textContent=pe,I=s(),w=r("ol"),w.innerHTML=me,F=s(),o(y.$$.fragment),N=s(),v=r("p"),v.textContent=ce,X=s(),o(b.$$.fragment),Q=s(),T=r("p"),T.innerHTML=fe,Y=s(),o(M.$$.fragment),W=s(),k=r("blockquote"),k.innerHTML=he,Z=s(),S=r("p"),S.innerHTML=ue,z=s(),_=r("p"),_.innerHTML=de,K=s(),o(U.$$.fragment),O=s(),L=r("p"),L.textContent=$e,D=s(),o(C.$$.fragment),ee=s(),o(E.$$.fragment),te=s(),x=r("p"),x.innerHTML=ge,le=s(),o(P.$$.fragment),ae=s(),o(R.$$.fragment),se=s(),H=r("p"),H.innerHTML=we,ie=s(),o(J.$$.fragment),re=s(),B=r("p"),this.h()},l(e){const t=Ue("svelte-u9bgzb",document.head);d=n(t,"META",{name:!0,content:!0}),t.forEach(l),j=i(e),A=n(e,"P",{}),ye(A).forEach(l),V=i(e),p($.$$.fragment,e),q=i(e),g=n(e,"P",{"data-svelte-h":!0}),m(g)!=="svelte-7o8ab0"&&(g.textContent=pe),I=i(e),w=n(e,"OL",{"data-svelte-h":!0}),m(w)!=="svelte-11w3dc8"&&(w.innerHTML=me),F=i(e),p(y.$$.fragment,e),N=i(e),v=n(e,"P",{"data-svelte-h":!0}),m(v)!=="svelte-aqne5f"&&(v.textContent=ce),X=i(e),p(b.$$.fragment,e),Q=i(e),T=n(e,"P",{"data-svelte-h":!0}),m(T)!=="svelte-nahn2r"&&(T.innerHTML=fe),Y=i(e),p(M.$$.fragment,e),W=i(e),k=n(e,"BLOCKQUOTE",{"data-svelte-h":!0}),m(k)!=="svelte-eq7jyu"&&(k.innerHTML=he),Z=i(e),S=n(e,"P",{"data-svelte-h":!0}),m(S)!=="svelte-18efqzs"&&(S.innerHTML=ue),z=i(e),_=n(e,"P",{"data-svelte-h":!0}),m(_)!=="svelte-1ukksq4"&&(_.innerHTML=de),K=i(e),p(U.$$.fragment,e),O=i(e),L=n(e,"P",{"data-svelte-h":!0}),m(L)!=="svelte-15yaip6"&&(L.textContent=$e),D=i(e),p(C.$$.fragment,e),ee=i(e),p(E.$$.fragment,e),te=i(e),x=n(e,"P",{"data-svelte-h":!0}),m(x)!=="svelte-1kfcgmh"&&(x.innerHTML=ge),le=i(e),p(P.$$.fragment,e),ae=i(e),p(R.$$.fragment,e),se=i(e),H=n(e,"P",{"data-svelte-h":!0}),m(H)!=="svelte-16yprl8"&&(H.innerHTML=we),ie=i(e),p(J.$$.fragment,e),re=i(e),B=n(e,"P",{}),ye(B).forEach(l),this.h()},h(){ve(d,"name","hf:doc:metadata"),ve(d,"content",xe)},m(e,t){Le(document.head,d),a(e,j,t),a(e,A,t),a(e,V,t),c($,e,t),a(e,q,t),a(e,g,t),a(e,I,t),a(e,w,t),a(e,F,t),c(y,e,t),a(e,N,t),a(e,v,t),a(e,X,t),c(b,e,t),a(e,Q,t),a(e,T,t),a(e,Y,t),c(M,e,t),a(e,W,t),a(e,k,t),a(e,Z,t),a(e,S,t),a(e,z,t),a(e,_,t),a(e,K,t),c(U,e,t),a(e,O,t),a(e,L,t),a(e,D,t),c(C,e,t),a(e,ee,t),c(E,e,t),a(e,te,t),a(e,x,t),a(e,le,t),c(P,e,t),a(e,ae,t),c(R,e,t),a(e,se,t),a(e,H,t),a(e,ie,t),c(J,e,t),a(e,re,t),a(e,B,t),ne=!0},p:Me,i(e){ne||(f($.$$.fragment,e),f(y.$$.fragment,e),f(b.$$.fragment,e),f(M.$$.fragment,e),f(U.$$.fragment,e),f(C.$$.fragment,e),f(E.$$.fragment,e),f(P.$$.fragment,e),f(R.$$.fragment,e),f(J.$$.fragment,e),ne=!0)},o(e){h($.$$.fragment,e),h(y.$$.fragment,e),h(b.$$.fragment,e),h(M.$$.fragment,e),h(U.$$.fragment,e),h(C.$$.fragment,e),h(E.$$.fragment,e),h(P.$$.fragment,e),h(R.$$.fragment,e),h(J.$$.fragment,e),ne=!1},d(e){e&&(l(j),l(A),l(V),l(q),l(g),l(I),l(w),l(F),l(N),l(v),l(X),l(Q),l(T),l(Y),l(W),l(k),l(Z),l(S),l(z),l(_),l(K),l(O),l(L),l(D),l(ee),l(te),l(x),l(le),l(ae),l(se),l(H),l(ie),l(re),l(B)),l(d),u($,e),u(y,e),u(b,e),u(M,e),u(U,e),u(C,e),u(E,e),u(P,e),u(R,e),u(J,e)}}}const xe='{"title":"Web Search","local":"web-search","sections":[{"title":"Providers","local":"providers","sections":[{"title":"Local","local":"local","sections":[],"depth":3},{"title":"SearXNG","local":"searxng","sections":[],"depth":3},{"title":"Third Party","local":"third-party","sections":[],"depth":3}],"depth":2},{"title":"Block/Allow List","local":"blockallow-list","sections":[],"depth":2},{"title":"Disabling Javascript","local":"disabling-javascript","sections":[],"depth":2}],"depth":1}';function Pe(oe){return ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ae extends Se{constructor(d){super(),_e(this,d,Pe,Ee,Te,{})}}export{Ae as component};
